/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/


//#include "typedefine.h"
#include <machine.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <mathf.h>
#include <complex.h>
#include "sound_effector.h"


#define AD_VAL_CHANGE_THRESHOLD 3		//A/DϊlnȏωۂɁAVlǂݎ

#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

void main(void)
{

	unsigned long prev_inbuf_wp;
	
	int i;
	
	pcm_data pcm_tmp;
	
	long delay_points;
	long delay_index;
	
	unsigned short volume1_val=0;		//VR1̓ǂݎliAD_VAL_CHANGE_THRESHOLDȉ̗h炬͔fȂj
	unsigned short mute=0;				//VR1ω͏o͂~[gƂ
	
	//֐
	sound_effector_init();
	
	sound_effector_start();		//Jn
	
	prev_inbuf_wp = 0;

	while(1)
	{
		if(g_sw_state == 0)
		{
			//X[
			if(prev_inbuf_wp != g_inbuf_wp)
			{
				for(i = 0; i < INBUF_UNIT_SIZE; i++)			//f[^ INBUF_UNIT_SIZE ܂
				{
					put_data(g_inbuf[prev_inbuf_wp + i]);		//̓obt@̒l𖢉Hŏo̓obt@Ɋi[
				}
				prev_inbuf_wp = g_inbuf_wp;						//̓obt@̃|C^lۑ
				
#ifdef DEBUG
				g_err_led_patturn = LED_OFF;
#endif
			}
		}
		else
		{
			//fBC
			if(prev_inbuf_wp != g_inbuf_wp)	//f[^ INBUF_UNIT_SIZE ܂
			{

				//{[lǂݎ
				if( ((volume1_val + AD_VAL_CHANGE_THRESHOLD) <= g_ad_val[0]) ||  ((volume1_val - AD_VAL_CHANGE_THRESHOLD) >= g_ad_val[0]) )
				{
					//g_ad_val[0]  AD_VAL_CHANGE_THRESHOLD ȏωꍇ
					volume1_val = g_ad_val[0];
					mute = 20;						//o͂̉ʂi20A5.33ms x 20 = 0.1bj
				}
				else
				{
					//{[̕ωȂꍇ́AXɃ~[g
					if(mute != 0) mute--;
				}
				
				//fBCl̎Zoiő2bj
				delay_points = (long)(((float)volume1_val / 4096.0) * (float)PCM_FS * 2.0);
			
				delay_index = prev_inbuf_wp - delay_points;				//fBC(g_delay_points)ɉCfbNXvZ, prev_inbuf_wp  delay_points ߋ̃f[^ɃANZX
				if(delay_index < 0) delay_index += INBUF_SIZE;	
				
				for(i = 0; i < INBUF_UNIT_SIZE; i++)
				{
					
					if(mute == 0)
					{
						put_data(g_inbuf[delay_index++]);				//ʏ
					}
					else
					{	
						//{[̓vcvch߁Aʂ~[gi{[ωȂꍇ͏Xɉʂ񕜂)
						pcm_tmp.ch0 = g_inbuf[delay_index].ch0 / mute;
						pcm_tmp.ch1 = g_inbuf[delay_index].ch1 / mute;
						delay_index++;
						put_data(pcm_tmp);
					}
					
					if(delay_index >= INBUF_SIZE) delay_index=0;		//INBUF_UNIT_SIZE  INBUF_SIZE  1/nin:jɂȂĂꍇ͕svȂ͂ł邪ꉞ
				}

				prev_inbuf_wp = g_inbuf_wp;

#ifdef DEBUG
				g_err_led_patturn = 0x00000001;
#endif
			}
		}
	}//while
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
